import tkinter as tk
import itertools

liste_mots = []
exp_reg_devant = ''
exp_reg_derriere = ''
nombre_combi = 0
fichier = 'mdp.txt'

fenetre = tk.Tk()
fenetre.minsize(860,250)
fenetre.maxsize(860,250)
fenetre.title("Créateur de listes de mdp")
fenetre.iconphoto(False, tk.PhotoImage(file='favicon.png'))

def ajouter_mot_liste():
    mot_ajouter = entree_liste.get()
    liste_mots.append(mot_ajouter)
    return liste_mots

def ajouter_exp_devant():
    global exp_reg_devant
    exp_reg_devant = entree_expression_devant.get()
    return exp_reg_devant

def ajouter_exp_derriere():
    global exp_reg_derriere
    exp_reg_derriere = entree_expression_derriere.get()
    return exp_reg_derriere

def valider_nombre_combi():
    global nombre_combi
    nombre_combi = entree_nombre_combi.get()
    return int(nombre_combi)

def reinitialiser_liste():
    global liste_mots
    liste_mots.clear()
    return liste_mots

def reinit_exp_devant():
    global exp_reg_devant
    exp_reg_devant = ''
    return exp_reg_devant

def reinit_exp_derriere():
    global exp_reg_derriere
    exp_reg_derriere = ''
    return exp_reg_derriere

def reinit_nombre_combi():
    global nombre_combi
    nombre_combi = 0
    return nombre_combi

def creation_du_fichier(liste_mots, nombre_combi, exp_reg_devant, exp_reg_derriere):
    permutations = list(itertools.permutations(liste_mots, int(nombre_combi)))
    resultat = ["".join(perm) for perm in permutations]
    permutations_chaines = [exp_reg_devant + ''.join(i) + exp_reg_derriere for i in resultat]
    with open(fichier, "w", encoding="utf8") as f:
        for n in permutations_chaines:
            f.write(n + "\n")
    print("Votre fichier texte a été créé dans ce répertoire sous le nom de mdp.txt.")

frame1 = tk.Frame(fenetre)
label_liste = tk.Label(frame1,text="Entrez un mot à ajouter à la liste.",
                       bg='#33ff9c',width=45, height=2)
entree_liste = tk.Entry(frame1, width=43)
bouton_liste = tk.Button(frame1,text="+",command=ajouter_mot_liste, bg='#33ff9c', width=1, height=1)
bouton_reinitialiser_liste = tk.Button(frame1,text="X",command=reinitialiser_liste, bg='#33ff9c', width=1, height=1)

frame2 = tk.Frame(fenetre)
frame3 = tk.Frame(fenetre)
label_expression_devant = tk.Label(frame2,text="Entrez une expression fixe devant chaque mdp.", bg="#ffc433",width=45, height=2)
label_expression_derriere = tk.Label(frame3,text="Entrez une expression fixe derrière chaque mdp.", bg="#9f33ff",width=45, height=2) 
entree_expression_devant = tk.Entry(frame2, width=43) 
entree_expression_derriere = tk.Entry(frame3, width=43)
bouton_expression_devant = tk.Button(frame2,text="+",command=ajouter_exp_devant, bg="#ffc433", width=1, height=1)
bouton_expression_derriere = tk.Button(frame3,text="+",command=ajouter_exp_derriere, bg="#9f33ff", width=1, height=1)
bouton_reinit_devant = tk.Button(frame2,text="X",command=reinit_exp_devant, bg="#ffc433", width=1, height=1)
bouton_reinit_derriere = tk.Button(frame3,text="X",command=reinit_exp_derriere, bg="#9f33ff", width=1, height=1)

frame4 = tk.Frame(fenetre)
label_nombre_combi = tk.Label(frame4,text="Tapez le nombre de mots par mdp.", bg="#33e3ff",width=45, height=2)
entree_nombre_combi = tk.Entry(frame4, width=43)
bouton_nombre_combi = tk.Button(frame4,text="+",command=valider_nombre_combi, bg="#33e3ff", width=1, height=1)
bouton_reinit_combi = tk.Button(frame4,text="X",command=reinit_nombre_combi, bg="#33e3ff", width=1, height=1)

bouton_run = tk.Button(text="Clic pour créer le fichier de mdp",command= lambda : creation_du_fichier(liste_mots, nombre_combi, exp_reg_devant, exp_reg_derriere), bg='red', width=45, height=2)

frame1.grid(row=0, column=0)
frame2.grid(row=0, column=1)
frame3.grid(row=1, column=0)
frame4.grid(row=1, column=1)

label_nombre_combi.grid(row=0, column=0, columnspan=3)
entree_nombre_combi.grid(row=1,column=0)
bouton_nombre_combi.grid(row=1,column=1)
bouton_reinit_combi.grid(row=1,column=2)

label_expression_devant.grid(row=0, column=0, columnspan=3)
entree_expression_devant.grid(row=1,column=0)
bouton_expression_devant.grid(row=1,column=1)
bouton_reinit_devant.grid(row=1,column=2)
label_expression_derriere.grid(row=0, column=0, columnspan=3)
entree_expression_derriere.grid(row=1,column=0)
bouton_expression_derriere.grid(row=1,column=1)
bouton_reinit_derriere.grid(row=1,column=2)

label_liste.grid(row=0, column=0, columnspan=3)
entree_liste.grid(row=1,column=0)
bouton_liste.grid(row=1,column=1)
bouton_reinitialiser_liste.grid(row=1,column=2)

bouton_run.grid(row=2, column=0, columnspan=2, pady=30)
fenetre.mainloop()














































